## sphinxsearch 2.2.11

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

FOREACH (policy CMP0012 CMP0013 CMP0014)
	IF (POLICY ${policy})
		CMAKE_POLICY (SET ${policy} NEW)
	ENDIF ()
ENDFOREACH ()

# override default options which affects windows builds
# that is necessary to change /MD to /MT, and also to set libraries on win to implicitly defined
set (CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
set (CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)

PROJECT (SPHINXSEARCH)
SET (SPHINXSEARCH_CMAKE_DIR "${SPHINXSEARCH_SOURCE_DIR}/cmake")
SET (CMAKE_MODULE_PATH "${SPHINXSEARCH_SOURCE_DIR}/cmake")
SET (EXTRA_LIBRARIES)
SET (BANNER)
list (APPEND BANNER "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")

set (SPHINX_TAG "" CACHE STRING "The tag which will be added to build")
set (SPHINX_PACKAGE_SUFFIX "")

if (WIN32)
	# on Win we skip all the tests and just use pre-defined folder
	include (select_library_dir)
	include (CMakeDependentOption)
	#	expat iconv mysql pq
	if (HAVE_expat)
		option (WITH_EXPAT "compile with libexpat support" ON)
		if (WITH_EXPAT)
			set (USE_LIBEXPAT 1)
			include_directories (${expat_INCLUDE})
			CMAKE_DEPENDENT_OPTION (DL_EXPAT "load expat library dynamically" OFF "USE_LIBEXPAT" ON)
			if (DL_EXPAT)
				set (DL_EXPAT 1)
				set (EXPAT_LIB libexpat.dll)
			else( DL_EXPAT )
				list (APPEND EXTRA_LIBRARIES ${expat_LIB})
			endif ()
			install (FILES ${expat_ROOT}/libs/libexpat.dll DESTINATION bin COMPONENT APPLICATIONS)
		endif ()
	endif ()

	if (HAVE_iconv)
		option (WITH_ICONV "compile with iconv support" ON)
		if (WITH_ICONV)
			set (USE_LIBICONV 1)
			include_directories (${iconv_INCLUDE})
			list (APPEND EXTRA_LIBRARIES ${iconv_LIB})
			install (FILES ${iconv_ROOT}/bin/iconv.dll DESTINATION bin COMPONENT APPLICATIONS)
		endif ()
	endif ()

	if (HAVE_mysql)
		option (WITH_MYSQL "compile with mysql support" ON)
		if (WITH_MYSQL)
			set (USE_MYSQL 1)
			include_directories (${mysql_INCLUDE})

			CMAKE_DEPENDENT_OPTION (DL_MYSQL "load mysql library dynamically" OFF "USE_MYSQL" ON)
			if (DL_MYSQL)
				set (DL_MYSQL 1)
				set (MYSQL_LIB libmysql.dll)
			else( DL_MYSQL )
				list (APPEND EXTRA_LIBRARIES ${mysql_LIB})
			endif ()
			install (FILES ${mysql_ROOT}/bin/libmysql.dll DESTINATION bin COMPONENT APPLICATIONS)
		endif ()
	endif ()

	if (HAVE_pq)
		option (WITH_PGSQL "compile with pq support" OFF)
		if (WITH_PGSQL)
			set (USE_PGSQL 1)
			include_directories (${pq_INCLUDE})

			CMAKE_DEPENDENT_OPTION (DL_PGSQL "load pgsql library dynamically" OFF "USE_PGSQL" ON)
			if (DL_PGSQL)
				set (DL_PGSQL 1)
				set (PGSQL_LIB libpq.dll)
			else( DL_PGSQL )
				list (APPEND EXTRA_LIBRARIES ${pq_LIB})
			endif ()
			set (SPHINX_PACKAGE_SUFFIX "${SPHINX_PACKAGE_SUFFIX}-pgsql")
			IF (CMAKE_EXE_LINKER_FLAGS MATCHES "x64")
				install (FILES
						${pq_ROOT}/bin/libeay32.dll
						${pq_ROOT}/bin/libiconv-2.dll
						${pq_ROOT}/bin/libintl-8.dll
						${pq_ROOT}/bin/libpq.dll
						${pq_ROOT}/bin/ssleay32.dll
						DESTINATION bin COMPONENT APPLICATIONS)
			else()
				install (FILES
						${pq_ROOT}/bin/libeay32.dll
						${pq_ROOT}/bin/libiconv.dll
						${pq_ROOT}/bin/libintl.dll
						${pq_ROOT}/bin/libpq.dll
						${pq_ROOT}/bin/ssleay32.dll
						DESTINATION bin COMPONENT APPLICATIONS)
			endif ()
		endif ()
	endif ()
	mark_as_advanced(CMAKE_CONFIGURATION_TYPES)
else (WIN32)

	include (helpers)

	message (STATUS "Checking for gcc version")
	include (check_veryold_gcc)
	message (STATUS "Checking for endianess")
	include (SphEndianess)

	if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set (HAVE_GCC_LIKE ON)
	endif()

	if (HAVE_GCC_LIKE)
		set (CFLAGS "-fno-strict-aliasing -Wall -g")
		add_definitions ("-D_FILE_OFFSET_BITS=64")
		if (CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
			set (CFLAGS "${CFLAGS} -O2 -g")
		elseif (CMAKE_BULD_TYPE MATCHES Release)
			set (CFLAGS "-fno-strict-aliasing -Wall -O3")
			set (SPLIT_SYMBOLS OFF)
		elseif (NOT CMAKE_BUILD_TYPE MATCHES Debug)
			set (CFLAGS "${CFLAGS} -O3 -g")
		endif ()
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CFLAGS}")
		set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CFLAGS} -fno-rtti")

		# eliminate also some too noisy warnings from CLang
		if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-register -Wno-missing-exception-spec")
		endif()
	endif (HAVE_GCC_LIKE)

	message (STATUS "Storing compiler version")
	if ( HAVE_GCC_LIKE )
		execute_process (COMMAND "${CMAKE_CXX_COMPILER}" "-dumpversion" OUTPUT_VARIABLE gcc_ver)
		remove_crlf (COMPILER ${gcc_ver})
		message (STATUS "Compiler is ${COMPILER}")
	endif ()

	message (STATUS "Storing system name")
	if (UNIX AND NOT CYGWIN)
		execute_process (COMMAND "uname" "-a" OUTPUT_VARIABLE OS_UNAME)
		remove_crlf (OS_UNAME ${OS_UNAME})
	endif (UNIX AND NOT CYGWIN)

	message (STATUS "Looking for threads library")
	find_package (Threads REQUIRED)
	list (APPEND EXTRA_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})

	message (STATUS "Checking for standard header files")
	include (ac_header_stdc)

	message (STATUS "Checking for specific headers")
	ac_check_headers ("execinfo.h;syslog.h")

	# mb use something better. The code below is copy-pasted from automake script
	message (STATUS "Checking for library functions")
	ac_search_libs ("socket" "setsockopt" _DUMMY EXTRA_LIBRARIES)
	ac_search_libs ("nsl;socket;resolv" "gethostbyname" _DUMMY EXTRA_LIBRARIES)
	ac_search_libs ("m" "logf" HAVE_LOGF EXTRA_LIBRARIES)
	ac_search_libs ("dl;dld" "dlopen" HAVE_DL EXTRA_LIBRARIES)
	if (HAVE_DL)
		set (HAVE_DLOPEN 1)
		set (HAVE_DLERROR 1)
	endif (HAVE_DL)


	include (CheckFunctionExists)
	ac_check_funcs ("strnlen;pread;poll")
	ac_check_funcs ("backtrace;backtrace_symbols")
	ac_check_funcs ("mremap")
	ac_check_funcs ("nanosleep;pthread_mutex_timedlock")
	check_function_exists (epoll_ctl HAVE_EPOLL)
	ac_search_libs ("rt" "clock_gettime" HAVE_CLOCK_GETTIME EXTRA_LIBRARIES)

	message (STATUS "Checking for atomic function")
	include (check_atomic_intrinsics)

	message (STATUS "Checking for unaligned RAM access")
	include (check_unaligned_ram_access)

	message (STATUS "Configuring the options...")
	message (STATUS "Option DISABLE_MEMROUTINES ${DISABLE_MEMROUTINES}")
	option (DISABLE_MEMROUTINES "If the build is broken because new/delete override, this option will disable the overriding in sphinx")
	if (DISABLE_MEMROUTINES)
		SET (SPH_DONT_OVERRIDE_MEMROUTINES 1)
		list (APPEND BANNER "DISABLE_MEMROUTINES=ON")
	endif (DISABLE_MEMROUTINES)

	message (STATUS "Option USE_SYSLOG ${USE_SYSLOG}")
	CMAKE_DEPENDENT_OPTION (USE_SYSLOG "compile with possibility to use syslog for logging" ON "HAVE_SYSLOG_H" OFF)
	IF (USE_SYSLOG)
		set (USE_SYSLOG 1)
	else(USE_SYSLOG)
		unset (USE_SYSLOG)
	ENDIF (USE_SYSLOG)

	message (STATUS "Option WITH_ODBC ${WITH_ODBC}")
	unset (_DUMMY_LIB)
	option_menu (ODBC "compile with UnixODBC support" USE_ODBC _DUMMY_LIB)

	message (STATUS "ODBC found is ${ODBC_FOUND}")

	CMAKE_DEPENDENT_OPTION (DL_UNIXODBC "load UnixODBC library dynamically" ON "USE_ODBC;HAVE_DL" OFF)
	if (DL_UNIXODBC)
		set (DL_UNIXODBC 1)
		GET_FILENAME_COMPONENT (UNIXODBC_LIB ${_DUMMY_LIB} NAME)
		message (STATUS "ODBC will be loaded dynamically in runtime as ${UNIXODBC_LIB}")
		list (APPEND BANNER "DL_UNIXODBC=ON")
	else( DL_UNIXODBC )
		list (APPEND EXTRA_LIBRARIES ${_DUMMY_LIB})
	endif (DL_UNIXODBC)

	message (STATUS "Option WITH_ZLIB ${WITH_ZLIB}")
	option_menu (ZLIB "compile with zlib support" USE_ZLIB EXTRA_LIBRARIES)


	message (STATUS "Option WITH_RLP ${WITH_RLP}")
	option (WITH_RLP "compile with RLP library support" OFF)
	if (WITH_RLP)
		if (EXISTS "${SPHINXSEARCH_SOURCE_DIR}/rlp/rlp/include/bt_rlp_c.h")
			set (USE_RLP 1)
		else()
			message (SEND_ERROR "missing RLP sources from librlp")
			unset (WITH_RLP CACHE)
		endif ()
	endif (WITH_RLP)

	# test for EXPAT
	message (STATUS "Option WITH_EXPAT ${WITH_EXPAT}")
	unset (_DUMMY_LIB)
	option_menu (EXPAT "compile with libexpat support" USE_LIBEXPAT _DUMMY_LIB)
	CMAKE_DEPENDENT_OPTION (DL_EXPAT "load expat library dynamically" ON "USE_LIBEXPAT;HAVE_DL" OFF)
	if (DL_EXPAT)
		set (DL_EXPAT 1)
		GET_FILENAME_COMPONENT (EXPAT_LIB ${_DUMMY_LIB} NAME)
		message (STATUS "EXPAT will be loaded dynamically in runtime as ${EXPAT_LIB}")
		list (APPEND BANNER "DL_EXPAT=ON")
	else( DL_EXPAT )
		list (APPEND EXTRA_LIBRARIES ${_DUMMY_LIB})
	endif ()

	# test for ICONV
	message (STATUS "Option WITH_ICONV ${WITH_ICONV}")
	if (WITH_EXPAT)
		option_menu (ICONV "compile with iconv support" USE_LIBICONV EXTRA_LIBRARIES)
	endif (WITH_EXPAT)

	# test for MYSQL
	message (STATUS "Option WITH_MYSQL ${WITH_MYSQL}")
	option (WITH_MYSQL "compile with MySQL support" ON)
	set (WITH_MYSQL_INCLUDES "" CACHE PATH "path to MySQL header files")
	set (WITH_MYSQL_LIBS "" CACHE PATH "path to MySQL library")
	set (WITH_MYSQL_ROOT "" CACHE PATH "path to the MySQL bundle (where both header and library lives)")

	if (WITH_MYSQL)
		find_package (MYSQL)

		if (MYSQL_FOUND)
			set (USE_MYSQL 1)
			include_directories (${MYSQL_INCLUDE_DIR})

			# -DNDEBUG we set or reset on global level, so purge it from myqsl flags
			string (REPLACE "-DNDEBUG" "" MYSQL_CXXFLAGS "${MYSQL_CXXFLAGS}")
			# keep only defs, include paths and libs
			string (REGEX MATCHALL "-[DLIl]([^ ]+)" MYSQL_CXXFLAGS "${MYSQL_CXXFLAGS}")
			# convert list after MATCHALL back to plain string
			string (REGEX REPLACE ";" " " MYSQL_CXXFLAGS "${MYSQL_CXXFLAGS}")

			if (MYSQL_CXXFLAGS)
				set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${MYSQL_CXXFLAGS}")
			endif (MYSQL_CXXFLAGS)
			CMAKE_DEPENDENT_OPTION (DL_MYSQL "load mysql library dynamically" ON "MYSQL_FOUND;HAVE_DL;NOT STATIC_MYSQL" OFF)
			CMAKE_DEPENDENT_OPTION (STATIC_MYSQL "link to mysql library statically" OFF "MYSQL_FOUND;NOT DL_MYSQL" OFF)
			if (STATIC_MYSQL)
				message (STATUS "Mysql will be linked statically")
				string (REGEX REPLACE "mysqlclient" "libmysqlclient.a" MYSQL_LIBRARIES "${MYSQL_LIBRARIES}")
			endif (STATIC_MYSQL)
			if (DL_MYSQL)
				message (STATUS "Mysql will not be linked (will be loaded at runtime)")
				set (DL_MYSQL 1)
				list (APPEND BANNER "DL_MYSQL=ON")
			else ( DL_MYSQL )
				list (APPEND EXTRA_LIBRARIES ${MYSQL_LIBRARIES})
			endif ()
			list (APPEND BANNER "MYSQL_LIB=${MYSQL_LIB}")
			list (APPEND BANNER "MYSQL_CONFIG_EXECUTABLE=${MYSQL_CONFIG_EXECUTABLE}")
		else (MYSQL_FOUND)
			message (SEND_ERROR
					"********************************************************************************
					ERROR: cannot find MySQL libraries. If you want to compile with MySQL support,
					you must either specify file locations explicitly using
					-D WITH_MYSQL_INCLUDES=... and -D WITH_MYSQL_LIBS=... options, or make sure path to
					mysql_config is listed in your PATH environment variable. Or specify the path usint
					-D MYSQL_CONFIG_EXECUTABLE=/path/to/mysql_config. If you want to
					disable MySQL support, use -D WITH_MYSQL=OFF option.
					********************************************************************************")
		endif (MYSQL_FOUND)
	endif (WITH_MYSQL)

	# test for POSTGRESQL
	message (STATUS "Option WITH_PGSQL ${WITH_PGSQL}")
	option (WITH_PGSQL "compile with PostgreSQL support" OFF)
	set (WITH_PGSQL_INCLUDES "" CACHE PATH "path to PostgreSQL header files")
	set (WITH_PGSQL_LIBS "" CACHE PATH "path to PostgreSQL library")

	if (WITH_PGSQL)
		if (WITH_PGSQL_INCLUDES)
			set (PostgreSQL_INCLUDE_DIR ${WITH_PGSQL_INCLUDES})
		endif (WITH_PGSQL_INCLUDES)

		if (WITH_PGSQL_LIBS)
			set (PostgreSQL_LIBRARIES ${WITH_PGSQL_LIBS}/libpq.so)
		endif (WITH_PGSQL_LIBS)

		if (NOT (WITH_PGSQL_INCLUDES AND WITH_PGSQL_LIBS))
			find_package (PostgreSQL)
		endif ()

		if (PostgreSQL_FOUND)
			set (USE_PGSQL 1)
			include_directories (${PostgreSQL_INCLUDE_DIRS})

			CMAKE_DEPENDENT_OPTION (DL_PGSQL "load pgsql library dynamically" ON "PostgreSQL_FOUND;HAVE_DL;NOT STATIC_PGSQL" OFF)

=== libre2/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

PROJECT(RE2)
#Parses Makefile and creates the own project based on it
#(actually we only use OFILES var from there)

FILE(READ "${CMAKE_CURRENT_SOURCE_DIR}/MakefileOrig" _CONTENT)
# replace '\ ' into one big line
STRING(REGEX REPLACE "\\\\\n" " " _CONTENT "${_CONTENT}")
# escape ';' (if any)
STRING(REGEX REPLACE ";" "\\\\;" _CONTENT "${_CONTENT}")
# now replace lf into ';' (it makes list from the line)
STRING(REGEX REPLACE "\n" ";" _CONTENT "${_CONTENT}")
FOREACH (LINE ${_CONTENT})
	# skip comments (beginning with #)
	IF(NOT "${LINE}" MATCHES "^#.*")
		# parse 'name=value1 value2..." - extract the 'name' part
		STRING(REGEX REPLACE "=.*$" "" _NAME "${LINE}")
		# extract the list of values part
		STRING(REGEX REPLACE "^.*=" "" _LIST "${LINE}")
		# replace (multi)spaces into ';' (it makes list from the line)
		separate_arguments(_LIST UNIX_COMMAND "${_LIST}")
		# finally get our two variables
		if ( _NAME STREQUAL "OFILES" )
			SET (_OBJ "${_LIST}")
		endif()
		# INSTALL_HFILES and HFILES are not necessary for build,
		# however it is good if we put them into solution (just for a human that will open them)
		if ( _NAME STREQUAL "INSTALL_HFILES" )
        	SET (_IHF "${_LIST}")
        	source_group ("Install headers" FILES ${_IHF})
        endif()
        if ( _NAME STREQUAL "HFILES" )
        	SET (_HF "${_LIST}")
        	source_group ("Headers" FILES ${_HF})
		endif()
	endif()
endforeach()

if ( _OBJ )
	set (SOURCES "")
	foreach(OBJ ${_OBJ})
		get_filename_component(NAME ${OBJ} NAME_WE)
		get_filename_component(DIR ${OBJ} DIRECTORY)
		# exclude leading 'obj/' from all the paths.
		STRING(REGEX REPLACE "^obj/" "" DIR "${DIR}")
		LIST(APPEND SOURCES "${DIR}/${NAME}.cc")
	endforeach()
else(_OBJ)
	MESSAGE(ERROR "No OFILE definition found in Makefile")
endif(_OBJ)


include_directories(".")
IF(CMAKE_COMPILER_IS_GNUCXX)
    SET(CMAKE_CXX_FLAGS "-Wall -O3 -g -pthread -Wsign-compare -c ")
ELSEIF (MSVC)
	set (CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Oi /GL")
	add_definitions("/D NOMINMAX")
ENDIF()
add_definitions("-DNDEBUG")
add_library ( RE2 STATIC ${SOURCES} ${_HF} ${_IHF} )

=== libstemmer_c/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

PROJECT(stemmer)
FILE(READ "${CMAKE_CURRENT_SOURCE_DIR}/mkinc.mak" _CONTENT)
# replace '\ ' into one big line
STRING(REGEX REPLACE "\\\\\n" " " _CONTENT "${_CONTENT}")
# escape ';' (if any)
STRING(REGEX REPLACE ";" "\\\\;" _CONTENT "${_CONTENT}")
# now replace lf into ';' (it makes list from the line)
STRING(REGEX REPLACE "\n" ";" _CONTENT "${_CONTENT}")
FOREACH (LINE ${_CONTENT})
	# skip comments (beginning with #)
	IF(NOT "${LINE}" MATCHES "^#.*")
		# parse 'name=value1 value2..." - extract the 'name' part
		STRING(REGEX REPLACE "=.*$" "" _NAME "${LINE}")
		# extract the list of values part
		STRING(REGEX REPLACE "^.*=" "" _LIST "${LINE}")
		# replace (multi)spaces into ';' (it makes list from the line)
		STRING(REGEX REPLACE " +" ";" _LIST "${_LIST}")
		# finally get our two variables
		IF("${_NAME}" MATCHES "snowball_sources")
			SET (_SOURCES "${_LIST}")
		ELSEIF ("${_NAME}" MATCHES "snowball_headers")
			SET (_HEADERS "${_LIST}")
		ENDIF()
	endif()
endforeach()
# all the sources parsed. Now just add the lib
add_library (stemmer STATIC ${_SOURCES} ${_HEADERS})
#SET (STEMMER_INCLUDE_DIR "${SPHINXSEARCH_SOURCE_DIR}/libstemmer_c/include" PARENT_SCOPE )
#SET (STEMMER_LIBRARIES stemmer PARENT_SCOPE)
#SET (STEMMER_FOUND TRUE PARENT_SCOPE)
#MARK_AS_ADVANCED(STEMMER_INCLUDE_DIR )

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# main bunch of sources (for libsphinx)
set (LIBSPHINX_SRCS sphinx.cpp sphinxexcerpt.cpp
		sphinxquery.cpp sphinxsoundex.cpp sphinxmetaphone.cpp
		sphinxstemen.cpp sphinxstemru.cpp sphinxstemcz.cpp
		sphinxstemar.cpp sphinxutils.cpp sphinxstd.cpp
		sphinxsort.cpp sphinxexpr.cpp sphinxfilter.cpp
		sphinxsearch.cpp sphinxrt.cpp sphinxjson.cpp
		sphinxaot.cpp sphinxplugin.cpp
		sphinxudf.c)
set (INDEXER_SRCS indexer.cpp)
set (INDEXTOOL_SRCS indextool.cpp)
set (SEARCHD_SRCS searchd.cpp)
set (SPELLDUMP_SRCS spelldump.cpp)
set (TESTS_SRCS tests.cpp)

# The headers is not neccessary for executable build, but nesessary for MSVC and other projects
# all the (non-generated) headers
file (GLOB HEADERS "sphinx*.h" lz4.h lz4hc.h http/http_parser.h)

file (GLOB GHEADERS "yysphinx*.h")
source_group ("Generated Header Files" FILES ${GHEADERS})

add_custom_target (
		generate_sphinxversion
		COMMAND
		${CMAKE_COMMAND}
		-D SOURCE_DIR=${CMAKE_SOURCE_DIR}
		-D BINARY_DIR=${CMAKE_BINARY_DIR}
		-D SPHINX_TAG="${SPHINX_TAG}"
		-P ${CMAKE_SOURCE_DIR}/sphinxrev.cmake
)
include_directories ("${SPHINXSEARCH_BINARY_DIR}/config")
add_definitions ("-DBUILD_WITH_CMAKE")

# our mega-lib
add_library (libsphinx STATIC ${LIBSPHINX_SRCS} ${HEADERS} ${GHEADERS})

add_dependencies (libsphinx generate_sphinxversion)

#message (STATUS "Extra libraries:${EXTRA_LIBRARIES}")

# our executables
add_executable (indexer ${INDEXER_SRCS})
add_executable (indextool ${INDEXTOOL_SRCS})
add_executable (searchd ${SEARCHD_SRCS})
add_executable (spelldump ${SPELLDUMP_SRCS})
add_executable (tests ${TESTS_SRCS})
target_link_libraries (indexer libsphinx ${EXTRA_LIBRARIES})
target_link_libraries (indextool libsphinx ${EXTRA_LIBRARIES})
target_link_libraries (searchd libsphinx ${EXTRA_LIBRARIES})
target_link_libraries (spelldump libsphinx ${EXTRA_LIBRARIES})
target_link_libraries (tests libsphinx ${EXTRA_LIBRARIES})

# add the extra targets in the case we want on-the-fly grammar compiler
if (USE_BISON)

	set (BISON_DIR "${SPHINXSEARCH_BINARY_DIR}/config")

	BISON_TARGET (ExprParser sphinxexpr.y ${BISON_DIR}/bissphinxexpr.c)
	BISON_TARGET (SelectParser sphinxselect.y ${BISON_DIR}/bissphinxselect.c)
	BISON_TARGET (QueryParser sphinxquery.y ${BISON_DIR}/bissphinxquery.c)
	BISON_TARGET (SQLParser sphinxql.y ${BISON_DIR}/bissphinxql.c)
	BISON_TARGET (JsonParser sphinxjson.y ${BISON_DIR}/bissphinxjson.c)

	set_property (SOURCE sphinxexpr.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${BISON_ExprParser_OUTPUT_SOURCE})
	set_property (SOURCE sphinx.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${BISON_SelectParser_OUTPUT_SOURCE})
	set_property (SOURCE sphinxquery.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${BISON_QueryParser_OUTPUT_SOURCE})
	set_property (SOURCE searchd.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${BISON_SQLParser_OUTPUT_SOURCE})
	set_property (SOURCE sphinxjson.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${BISON_JsonParser_OUTPUT_SOURCE})

endif (USE_BISON)

# add the extra targets in the case we want on-the-fly lex compiler
if (USE_FLEX)
	set (FLEX_DIR "${SPHINXSEARCH_BINARY_DIR}/config")

	FLEX_TARGET (SQLlex sphinxql.l ${FLEX_DIR}/flexsphinxql.c COMPILE_FLAGS "-i")
	FLEX_TARGET (Jsonlex sphinxjson.l ${FLEX_DIR}/flexsphinxjson.c COMPILE_FLAGS "-i -Pyy2")

	set_property (SOURCE searchd.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${FLEX_SQLlex_OUTPUTS})
	set_property (SOURCE sphinxjson.cpp APPEND PROPERTY
			OBJECT_DEPENDS ${FLEX_Jsonlex_OUTPUTS})

endif (USE_FLEX)


if (SPLIT_SYMBOLS)
	include(helpers)
	install_dbg (indexer)
	install_dbg (indextool)
	install_dbg (searchd)
	install_dbg (spelldump)
	install_dbg (tests)
endif (SPLIT_SYMBOLS)

INSTALL (TARGETS indexer indextool searchd spelldump RUNTIME DESTINATION bin COMPONENT APPLICATIONS)

# testrt is win-only project
if (WIN32)
	add_executable (testrt testrt.cpp)
	target_link_libraries (testrt libsphinx ${EXTRA_LIBRARIES})
endif (WIN32)

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# will add the tests from test suite
# each test will be added as separate one
file(GLOB tests "test_[0-9]*")
list(SORT tests)

foreach(test ${tests})
	# get the last dir (filename)
	get_filename_component(onetest "${test}" NAME_WE)
	# crop the 'test_' heading (so, only number is rest)
	STRING(REGEX REPLACE "^test_" "" onetest "${onetest}")

	# check if we can extract the name for the test from it
	if (EXISTS "${test}/test.xml")
		# open the file with the test
		file(READ ${test}/test.xml test_name LIMIT 1024)
		# cut out all from the beginning to '<name>'
		STRING(REGEX REPLACE "^.*<[Nn][Aa][Mm][Ee]>" "" test_name "${test_name}")
		# cut out all from the </name> to the end
    	STRING(REGEX REPLACE "</[Nn][Aa][Mm][Ee]>.*$" "" test_name "${test_name}")
    else()
    	set (test_name "")
    endif()
    set (test_name "${onetest} ${test_name}")

    add_test(NAME "\"${test_name}\""
#    	CONFIGURATIONS Debug
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    	COMMAND php ubertest.php -s $<TARGET_FILE:searchd> t ${onetest})

endforeach()

=== api/java/Makefile ===
#
# $Id$
#
# Makefile to automate sphinxapi.jar source builds
#

# order matters; full rebuild is always performed; but it somehow works
SOURCES = \
	SphinxMatch.java \
	SphinxException.java \
	SphinxWordInfo.java \
	SphinxResult.java \
	SphinxClient.java \
	test.java
CLASSES = $(SOURCES:.java=.class)

all : sphinxapi.jar

clean:
	rm -fr org
	rm -f sphinxapi.jar

sphinxapi.jar: $(CLASSES)
	jar cfm sphinxapi.jar MANIFEST.MF org/sphx/api

.SUFFIXES: .java .class
vpath %.class org/sphx/api
.java.class:
	javac -classpath . -d . $<

#
# $Id$
#

=== debian/changelog ===
sphinxsearch (2.2.11-8) unstable; urgency=medium

  * Fix FTBFS on Hurd: don’t call pthread_attr_setstacksize if
    PTHREAD_STACK_MIN is not defined.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 20:32:53 +0100

sphinxsearch (2.2.11-7) unstable; urgency=medium

  * Build-Depend on pkgconf.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 15:26:40 +0100

sphinxsearch (2.2.11-6) unstable; urgency=medium

  [ Helmut Grohne ]
  * Use pkg-config instead of mysql_config (Closes: #917137).

  [ Andrej Shadura ]
  * Build-Depend on unixodbc-dev.
  * Use pkg-config to detect libre2 (fixes FTBFS on non-x86).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 14:21:45 +0100

sphinxsearch (2.2.11-5) unstable; urgency=medium

  * New maintainer (Closes: #939763).
  * Add gbp.conf.
  * Convert copyright file to machine-readable format.
  * Add exclusions for current and future releases.
  * Simplify the init script (Closes: #861262, #772370, #656326).
  * Fix the crontab user (Closes: #656326).
  * Update the sample/minimal conf files to match installation paths.
  * Don't install an extra copy of the configuration sample.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set Standards-Version: 4.6.0.
  * Drop B-D on dh-autoreconf, autotools-dev and adduser.
  * Enable re2 support.
  * Move the example.sql to /usr/share/doc (Closes: #871944).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 10:41:03 +0100

sphinxsearch (2.2.11-4) unstable; urgency=medium

  * Trim trailing whitespace.
  * Drop use of autotools-dev debhelper.
  * Remove uploaders from orphaned package.
  * Wrap and sort.
  * Use debian-compat 13.
  * Simplify autoconf handing in debian/rules.
  * Fix the default address in the sample config
    (Closes: #939762, CVE-2019-14511)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 02 Dec 2021 20:31:20 +0100

sphinxsearch (2.2.11-3) unstable; urgency=medium

  [ Vasyl Gello ]
  * Fix arbitrary file reads by scattered file snippets
    (CVE-2020-29050)

  [ Lucas Kanashiro ]
  * Fix handshake implementation of MySQL protocol to support MySQL 8
    clients (LP: #1855468)

  [ Andrej Shadura ]
  * Update Maintainer/Uploaders (Closes: #858689)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 02 Dec 2021 20:13:11 +0100

sphinxsearch (2.2.11-2) unstable; urgency=medium

  * Fix upstream bug 2540: daemon crash on snippet generation
    for empty documents with html_strip enabled. (Closes: #869097)

 -- YunQiang Su <syq@debian.org>  Sun, 20 Aug 2017 11:08:24 +0800

sphinxsearch (2.2.11-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch Build-Depends to default-libmysqlclient-dev.
    (Closes: #845911)

 -- Christian Hofstaedtler <zeha@debian.org>  Mon, 19 Dec 2016 01:53:57 +0000

sphinxsearch (2.2.11-1) unstable; urgency=medium

  * New upstream release.
  * Bump standard version to 3.9.8.

 -- YunQiang Su <syq@debian.org>  Wed, 26 Oct 2016 13:49:22 +0800

=== debian/control ===
Source: sphinxsearch
Section: misc
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 docbook-to-man,
 gawk,
 libexpat-dev,
 libre2-dev,
 libpq-dev,
 libstemmer-dev,
 pkgconf,
 unixodbc-dev
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/sphinxsearch.git
Vcs-Browser: https://salsa.debian.org/debian/sphinxsearch

Package: sphinxsearch
Architecture: any
Depends:
 adduser,
 sysvinit-utils,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fast standalone full-text SQL search engine
 Sphinx is a standalone full text search engine, meant to provide fast,
 size-efficient and relevant fulltext search functions to other applications.
 Sphinx was specially designed to integrate well with SQL databases and
 scripting languages. Currently built-in data sources support fetching data
 either via direct connection to MySQL or PostgreSQL, or using XML pipe
 mechanism (a pipe to indexer in special XML-based format which Sphinx
 recognizes).
 .
 Sphinx is an acronym which is officially decoded as SQL Phrase Index.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            --localstatedir=/var/lib/sphinxsearch --sysconfdir=/etc/sphinxsearch --with-libstemmer --with-pgsql --with-re2

execute_after_dh_auto_install:
	# Move the examples
	mkdir -p debian/sphinxsearch/usr/share/doc/sphinxsearch
	mv debian/sphinxsearch/etc/sphinxsearch/sphinx.conf.dist debian/sphinxsearch/usr/share/doc/sphinxsearch/sphinx.conf.sample
	mv debian/sphinxsearch/etc/sphinxsearch/example.sql debian/sphinxsearch/usr/share/doc/sphinxsearch/

override_dh_auto_test:
